#! /usr/local/bin/perl -w

use GDBM_File;
use Getopt::Long;
use Storable qw(freeze thaw);
use Gtk;

Gtk->init();

#GetOptions(
#	   "builddb=s" => \$do_builddb,
#	   );

tie %gismu, "GDBM_File", "gismu.gdbm", &GDBM_READER, 0644
  or die "couldn't read database: $!";
tie %history, "GDBM_File", "gismu.flash.history", &GDBM_WRCREAT, 0644
  or die "couldn't write history database: $!";
# each gismu is a hashref of:
#  gismu
#  rafsi1 (CVC), rafsi2(CCV), rafsi3(CV'V)
#  english: a single-word english equivalent
#  metaphor: how the gismu might be used as a metaphor
#  place_structure: x1 is foo by x2 with x3 etc
#  code: lesson/sublesson number
#  number: frequency count
#  refs: (cf. other gismu)

$session = ++$history{'SESSION'};

print "starting session $session\n";

#@gismu = sort(keys(%gismu));
#print "db has ",scalar(@gismu)," gismu\n";

if (0) {
for $i (0 .. 10) {
    my $num = rand(@gismu);
    my $gismu = thaw($gismu{$gismu[$num]});
    print "$i: $gismu->{gismu}: $gismu->{english}\n";
}
}

{
    my $mw = Gtk::Widget->new("GtkWindow",
			      -type => 'toplevel',
			      -title => "Lojban Flash",
			      -border_width => 2);
    #$mw->set_usize(275,150);
    $mw->signal_connect("destroy", sub { Gtk->main_quit; });
    $mw->signal_connect("delete_event", sub {Gtk->main_quit; });

    my $v1 = Gtk::VBox->new(0,0);
    $v1->show();
    # top: menu bar
    {
	#my $h1 = Gtk::HBox->new(0,0);
	my $h1 = new Gtk::Label "menu placeholder";
	$h1->show();
	$v1->pack_start($h1, 0, 0, 2);
    }
    
    # middle: hbox with two sides of flash card on left and right
    {
	my $h1 = Gtk::HBox->new(0,0);
	my $f1 = new Gtk::Frame "Lojban";
	$f1->set_usize(150,100);
	$f1->show();
	$h1->pack_start($f1, 0, 0, 2);
	{
	    # fields from top:
	    # (label) gismu
	    # (text) place structure
	    my $v2 = Gtk::VBox->new(0,0);
	    my $gismu = Gtk::Label->new("gismu: GISMU");
	    $gismu->show();
	    $v2->pack_start($gismu, 1, 1, 0);
	    my $place = new Gtk::Entry;
	    $place->set_text("place structure: x1 does x2 to x3 with x4");
	    $place->show;
	    $v2->pack_end($place, 1, 1, 0);
	    $v2->show();
	    $f1->add($v2);
	}
	my $f2 = new Gtk::Frame "English";
	$f2->set_usize(150,100);
	$f2->show();
	$h1->pack_start($f2, 0, 0, 2);
	$h1->show();
	$v1->pack_start($h1, 0, 0, 2);
    }
    # bottom: buttons
    my $h3 = Gtk::HBox->new(0,0);
    $h3->show();
    $v1->pack_end($h3, 0, 0, 2);

    my $quit_button = Gtk::Widget->new("GtkButton",
				       -label => "Quit",
				       -clicked => sub {$mw->destroy},
				       -visible => 1);
    $quit_button->show();
    $h3->pack_end($quit_button, 1, 0, 2);

    $mw->add($v1);
    $mw->show();
}

Gtk->main();


