#! /usr/local/bin/perl -w

use GDBM_File;
use Getopt::Long;
use Storable qw(freeze thaw);

tie %rawgismu, "GDBM_File", "gismu.gdbm", &GDBM_READER, 0644
  or die "couldn't read database: $!";
# The gismu file is indexed by gismu. Each value is a frozen hashref of:
#  gismu
#  rafsi1 (CVC), rafsi2(CCV), rafsi3(CV'V)
#  english: a single-word english equivalent
#  metaphor: how the gismu might be used as a metaphor
#  place_structure: x1 is foo by x2 with x3 etc
#  code: lesson/sublesson number
#  number: frequency count
#  refs: (cf. other gismu)
print "thawing gismu..\n";
foreach (keys(%rawgismu)) {
    $gismu{$_} = thaw($rawgismu{$_});
}
print " done\n";

@gismu = sort(keys(%gismu));
print "db has ",scalar(@gismu)," gismu\n";

@sorted = sort {$gismu{$a}->{'number'} <=> $gismu{$b}->{'number'}} @gismu;
for $i (0 .. 10) {
    my $gismu = $sorted[$i];
    print "$i: (",$gismu{$gismu}->{'number'},") $gismu\n";
}

for $i (($#sorted - 10) .. $#sorted) {
    my $gismu = $sorted[$i];
    print "$i: (",$gismu{$gismu}->{'number'},") $gismu\n";
}

