#! /usr/local/bin/perl -w

# take a lojban word, figure out what part of speech it is, and look it up
# in the right dictionary

$ddir = "/usr/local/share/dict/lojban";

sub type {
    my($word) = @_;
    $word = lc($word);
    $word =~ s/[aeiou]/V/g;
    $word =~ s/[bcdfgjklmnprstvwxz]/C/g;
    $word =~ s/[\'\.]//g;
    return $word;
}

$line = join(' ',@ARGV);
@words = split(/\s+/, $line);
foreach (@words) {
    # gismu are always 5 letters and are either CVCCV or CCVCV
    my $type = type($_);
    if ($type eq "CVCCV" or $type eq "CCVCV") {
	my $def = `grep "^$_" $ddir/gismu`;
	chomp($def) if ($def);
	print "$_: gismu $def\n";

	next;
    }
    # cmavo
    if ($type eq "V" or $type eq "CV" or $type eq "VV" or $type eq "CVV") {
	my $search = $_;
	$search = " $search" unless ($search =~ /^\./);
	$search =~ s/\./\\./g;
	my $def = `grep "^$search  " $ddir/cmavo`;
	chomp($def) if $def;
	print "$_: cmavo $def\n";

	next;
    }
    # compound cmavo
    if ($type =~ /V$/ and $type !~ /CC/) {
	my $search = $_;
	$search = " $search" unless ($search =~ /^\./);
	$search =~ s/\./\\./g;
	my $def = `grep "^$search " $ddir/cmavo`;
	chomp($def) if $def;
	print "$_: compound cmavo $def\n";
	
	next;
    }
    print "$_: ??\n";
}
