#!/usr/local/bin/perl -w

use GDBM_File;
use Getopt::Long;

$dbmfile = "rafsi.gdbm";
$rafsifile = "rafsi";
unless ( GetOptions(
		    "dbfile=s" => \$dbmfile,
		    "rafsi=s" => \$rafsifile,
		   ))
{
    die "bad option\n";
}

print "Building rafsi database $dbmfile from rafsi in $rafsifile..\n";
tie %rafsi, "GDBM_File", $dbmfile, &GDBM_WRCREAT, 0644
  or die "couldn't create database: $!";
open(RAFSI, "<$rafsifile") or die "couldn't open rafsi: $!";
my $count = 0;
my $skip = 0;
while (<RAFSI>) {
    chomp;
    my($rafsi, $gismu) =
	 # 0   5
	 /^(.{4}) (.{5}) /;
    die "$.: '$_'" unless defined($gismu);
    unless ($gismu =~ /^[a-z]{5}$/) {
	#print "skipping $rafsi ($gismu)\n";
	$skip++;
	next;
    }
    $rafsi =~ s/\s+$//; $rafsi =~ s/^\s+//;
    $gismu =~ s/\s+$//; $gismu =~ s/^\s+//;
    
    my $bad = 0;
    print("$.: $gismu: not gismu\n"),$bad++
      unless length($gismu) == 5 and $gismu !~ /\'/;
    print("$.: rafsi $rafsi"),$bad++ if $rafsi =~ / /;
    print("$.: rafsi $rafsi"),$bad++ if $rafsi =~ tr/a-z/a-z/ != 3;
    if ($bad) {
	print "bad line $. '$_'\n";
	print "gismu: '$gismu'\n";
	print "rafsi: '$rafsi'\n";
	die;
    }
    
    $rafsi{$rafsi} = $gismu;
    $count++;
}
untie %rafsi;
close(RAFSI);
print "$count rafsi included, $skip non-rafsi skipped\n";
